<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="100px"
    >
<!--      <el-form-item label="锁具机构编码" prop="locksetCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.locksetCode"-->
<!--          placeholder="请输入锁具机构编码"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="锁具机构名称" prop="locksetName">
        <el-input
          v-model="queryParams.locksetName"
          placeholder="请输入锁具机构名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="锁具机构类型" prop="locksetTypeId">
        <el-tree-select
          v-model="queryParams.locksetTypeId"
          :data="locksetTypeOptions"
          :props="{ label: 'locksetTypeName', value: 'id', children: 'children' }"
          placeholder="请选择锁具机构类型"
          class="!w-240px"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['mes:hw:lk:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="danger"
          plain
          :disabled="!selectedIds.length"
          @click="handleDelete()"
          v-hasPermi="['mes:hw:lk:delete']"
        >
          <Icon icon="ep:delete" class="mr-5px" /> 批量删除
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>

    <el-table
      v-loading="loading"
      :data="list"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="锁具机构编码" prop="locksetCode" width="150" />-->
      <el-table-column label="锁具机构名称" prop="locksetName" width="180" :show-overflow-tooltip="true" />
      <el-table-column label="锁具机构类型" prop="locksetTypeName" />
      <el-table-column label="锁具机构NFC" prop="locksetNfc" />
      <el-table-column label="锁具机构RFID" prop="locksetRfid" />
      <el-table-column label="物资名称" prop="materialsName" />
      <el-table-column label="锁具机构型号" prop="locksetSpec" />
      <el-table-column label="创建时间" prop="createTime" width="180" :formatter="dateFormatter" />
      <el-table-column label="操作" align="center" width="150">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['mes:hw:lk:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['mes:hw:lk:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <Pagination
      v-model:total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗 -->
  <LocksetForm ref="formRef" @success="getList" />
</template>

<script lang="ts" setup>
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import { handleTree } from '@/utils/tree'
import * as LocksetApi from '@/api/hw/hardware/lockset/index'
import * as LocksetTypeApi from '@/api/hw/type/locksettype/index'
// import * as MaterialApi from '@/api/mes/material/information'
import LocksetForm from './LocksetForm.vue'
import {listLocksetType} from "@/api/hw/type/locksettype/index";
import {delLocksetAPI, listLocksetAPI} from "@/api/hw/hardware/lockset/index";

defineOptions({ name: 'LockInfo' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const showSearch = ref(true) // 是否显示搜索工作栏
const selectedIds = ref<number[]>([]) // 选中的数据编号
const locksetTypeOptions = ref([]) // 锁具机构类型选项

const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  locksetCode: undefined,
  locksetName: undefined,
  locksetTypeId: undefined
})

const queryFormRef = ref() // 搜索表单

/** 查询锁具机构列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await LocksetApi.listLocksetAPI(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 获取锁具机构类型列表 */
const getLockTypeList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await LocksetTypeApi.listLocksetType(data)
  locksetTypeOptions.value = handleTree(response.list, 'id', 'parentTypeId')
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields()
  handleQuery()
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: any[]) => {
  selectedIds.value = selection.map(item => item.id)
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id?: number) => {
  const ids = [id || selectedIds.value].join(',')
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await LocksetApi.delLocksetAPI(ids)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  await getLockTypeList()
})
</script>
